{*******************************************************}
{                                                       }
{             HTML Parser Component Demo                }
{                                                       }
{             Copyright (c) 2001 GERASoft               }
{                                                       }
{*******************************************************}

unit DemoForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, HTMLParser;

type
  TfrmDemo = class(TForm)
    btnUpdate: TButton;
    OpenDialog1: TOpenDialog;
    HTMLParser1: THTMLParser;
    memOut: TMemo;
    btnGrab: TButton;
    procedure FormShow(Sender: TObject);
    procedure btnUpdateClick(Sender: TObject);
    procedure btnGrabClick(Sender: TObject);
    procedure HTMLParser1HTMLTag(Sender: TObject; const TagName: String;
      TagParams: TParamsArray);
  private
    FUpdate : Boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDemo: TfrmDemo;

implementation

{$R *.DFM}


procedure TfrmDemo.FormShow(Sender: TObject);
begin
  OpenDialog1.InitialDir := ExtractFilePath(Application.ExeName);
end;


procedure TfrmDemo.btnUpdateClick(Sender: TObject);
begin
  memOut.Clear;
  FUpdate := True;
  if OpenDialog1.Execute then
    memOut.Lines.Add(HTMLParser1.ParseFile(OpenDialog1.FileName));
end;

procedure TfrmDemo.btnGrabClick(Sender: TObject);
begin
  memOut.Clear;
  FUpdate := False;
  if OpenDialog1.Execute then
    HTMLParser1.ParseFile(OpenDialog1.FileName);
end;

procedure TfrmDemo.HTMLParser1HTMLTag(Sender: TObject;  const TagName: String; TagParams: TParamsArray);

  procedure DoUpdate;
  var
    i : integer;
  begin
    for i := 0 to High(TagParams) do with TagParams[i] do
      if ((CompareText(Name,'src')=0)and
          (CompareText(TagName,'img')=0))or
         (CompareText(TagName,'background')=0)then
        Value := 'XXXXX.GIF';
  end;

  procedure DoGrab;
  var
    i : integer;
  begin
    if CompareText(TagName,'A')=0 then
      for i := 0 to High(TagParams) do with TagParams[i] do
        if CompareText(Name,'href')=0 then
          memOut.Lines.Add(QChar+Value+QChar);
  end;

begin
  if FUpdate then DoUpdate
  else DoGrab;
end;

end.
